// ************* TinyFlea microcomputer framework ************
// ** For use with Fleatiny system board revision 1.2+ PCBs **
// **************** Kernel build # 0051 **********************

// *************** kernel_sd.h module *******************
// SD card interface module for fleatiny 
// Provides initialisation and raw sector read/write of MMC/SD/SDHC cards 
// where the physical card sectors are 512 Bytes long ie 2GB SD cards will 
// not work without modification to the code contained in this module.


//  Copyright(c) 2012 Valentin Angelovski

//  This file is part of my Fleatiny embedded framework. Please refer 
//  to <http://www.fleasystems.com/fleatiny.html> for further info.

//  Fleatiny embedded framework is free software: you can redistribute it and/or 
//  modify it under the terms of the GNU Lesser General Public License as published 
//  by the Free Software Foundation, either version 3 of the License, or
//  (at your option) any later version.

//  Fleatiny embedded framework is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU Lesser General Public License for more details.

//   You should have received a copy of the GNU Lesser General Public License
//   along with Fleatiny embedded framework.  If not, see <http://www.gnu.org/licenses/>.




volatile __data unsigned char 	COUNT1 = 0;	// Various temporary byte regs
volatile __data unsigned char 	COUNT2 = 0;
volatile __data unsigned char 	COUNT3 = 0;
volatile __data unsigned char 	temp1 = 0;

volatile __data unsigned short Count;      	// local timeout counter
volatile __data unsigned char Retry;      	// local retry counter  
volatile __data unsigned char sd_respons1;      // local retry counter 
volatile __data unsigned char sd_respons2;      // local retry counter 
volatile __data unsigned char sd_respons3;      // local retry counter 
volatile __data unsigned char sd_respons4;      // local retry counter 
volatile __data unsigned char sd_respons5;      // local retry counter 

volatile __bit	sd_sector_read = 1;			// SD card read/write mode select flag;
volatile __bit	cmd8_good = 0;				// SD command #8 accepted flag;
volatile __bit	sd_hc = 0;				// SD High Capacity card detected flag;

volatile __data unsigned char sd_cmdpacket[6];
volatile __data unsigned char zi,za;
volatile __data unsigned char zcrc,zData;
volatile __data unsigned long soundplay_endsector;

__xdata __at (0x0200) unsigned char sd_buffer[512];		// Let the SD data transfer buffer sit just above the text buffer
